//the header file for Simulator

#ifndef __SIM_H
#define __SIM_H

#include <stdio.h>
#include "Node.h"

#define StopandWait	'\1'
#define GoBackN		'\2'
#define SelectiveRepeat	'\4'

class Simulator 
{
public:
    //Constructor, Get, Set etc.
    Simulator();
    ~Simulator();
    
    //Simulation Methods
    int readSettings ();
    int run();
    
private:
    int simulate();
    int verify();
    		
    //Data Members
private:
    Node Source;
    Node Sink;
    double propagationDelay;
    double processingDelay;
    double duration;
    int simulationSetSize;
    
    double* bitRate;
    int     nBitRate;
    double* dataPacketSize;
    int     nDataPacketSize;
    double* dataOverhead;
    int     nDataOverhead;
    double* ackSize;
    int     nAckSize;
    
public:
    static char settingsFile[256];
    static char arqMethod;
};

char* fgetLine(int maxChars, FILE* fp);
char** parseLine(char* string, char* separator);
int tokenCount(char* string, char* separator);
#endif
